#include "DXUT.h"
#include "DualQuaternion.h"

DualQuaternion::DualQuaternion(const D3DXQUATERNION& orientation, const D3DXVECTOR3& translation)
{
	set(orientation, translation);
}

void DualQuaternion::set(const D3DXQUATERNION& orientation, const D3DXVECTOR3& translation)
{
	this->orientation = orientation;
	const D3DXQUATERNION& q0 = orientation;
	const D3DXVECTOR3& t = translation;
	D3DXQUATERNION& dq = this->translation;
	dq[0] = -0.5*(t[0]*q0[1] + t[1]*q0[2] + t[2]*q0[3]);
	dq[1] = 0.5*( t[0]*q0[0] + t[1]*q0[3] - t[2]*q0[2]);
	dq[2] = 0.5*(-t[0]*q0[3] + t[1]*q0[0] + t[2]*q0[1]);
	dq[3] = 0.5*( t[0]*q0[2] - t[1]*q0[1] + t[2]*q0[0]);
}