#pragma once
#include "sas/DxaSas.h"
#include "sas/SasButton.h"
#include "Mesh.h"
#include "DXUTCamera.h"
#include "InputLayoutManager.h"

namespace Dxa
{
	class Import :
		public Dxa::Sas
	{
		#pragma region 12.3
		Mesh* backgroundQuad;
		ID3D11InputLayout* backgroundInputLayout;
		#pragma endregion background quad and input layout

		#pragma region 10.0
		ID3D11ShaderResourceView* envTextureSrv;
		#pragma endregion shader resource view

		#pragma region 8.2
		ID3D11ShaderResourceView* kdTextureSrv;
		#pragma endregion shader resource view

		#pragma region 6.3
		CFirstPersonCamera camera;
		Mesh* mesh;
		ID3D11InputLayout* inputLayout;
		#pragma endregion effect, mesh, input layout, camera

		InputLayoutManager* inputLayoutManager;
		const void* vertexData;
		const void* indexData;

		void loadEffect();

		void openFile();
		class OpenFileFunctor : public SasControl::Button::Functor
		{
			Dxa::Import* owner;
		public:
			OpenFileFunctor(Dxa::Import* owner):owner(owner){}
			void operator()()
			{
				owner->openFile();
			}
		};

		void saveFile();
		class SaveFileFunctor : public SasControl::Button::Functor
		{
			Dxa::Import* owner;
		public:
			SaveFileFunctor(Dxa::Import* owner):owner(owner){}
			void operator()()
			{
				owner->saveFile();
			}
		};

		#pragma region 6.2
	public:
		Import(ID3D11Device* device);
		HRESULT createResources();
		HRESULT releaseResources();
		HRESULT createSwapChainResources();
		HRESULT releaseSwapChainResources();
		void animate(double dt, double t);
		bool processMessage( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
		void render(ID3D11DeviceContext* context);

		#pragma endregion overridden event handlers
	};

}