#pragma once
#include "dxa.h"
#include "Mesh.h"
#include "DXUTCamera.h"

namespace Dxa
{

	class MeshCam :
		public Dxa::Base
	{
		#pragma region 6.3
		ID3DX11Effect* effect;
		CFirstPersonCamera camera;
		Mesh* mesh;
		ID3D11InputLayout* inputLayout;
		#pragma endregion effect, mesh, input layout, camera

		#pragma region 6.2
	public:
		MeshCam(ID3D11Device* device);
		HRESULT createResources();
		HRESULT releaseResources();
		HRESULT createSwapChainResources();
		HRESULT releaseSwapChainResources();
		void animate(double dt, double t);
		bool processMessage( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
		void render(ID3D11DeviceContext* context);

		#pragma endregion overridden event handlers
	};

}