#pragma once
#include "d3dx11effect.h"
#include <vector>

class Mesh;

class InputLayoutManager
{
	class InputConfiguration
	{
		friend class InputLayoutManager;

		const D3D11_INPUT_ELEMENT_DESC* elements;
		unsigned int nElements;
		const D3DX11_PASS_DESC& passDesc;

		ID3D11InputLayout* inputLayout;

		InputConfiguration(const D3DX11_PASS_DESC& passDesc, Mesh* mesh, bool instancing);

		/// Returns true if input signatures are identical and elements with shared semantics are also identical.
		bool isCompatible(const InputConfiguration& other) const;

		HRESULT createInputLayout(ID3D11Device* device);
	};

	typedef std::vector<InputConfiguration> InputConfigurationList;
	InputConfigurationList inputConfigurationList;

public:
	InputLayoutManager();
	~InputLayoutManager();

	ID3D11InputLayout* getCompatibleInputLayout(ID3D11Device* device, const D3DX11_PASS_DESC& passDesc, Mesh* mesh, bool instancing);
};
