#pragma once
#include "d3dx11effect.h"

class aiMesh;

class Mass
{
	ID3D11Buffer* vertexBuffer;
	ID3D11Buffer* indexBuffer;
	D3D11_INPUT_ELEMENT_DESC* elements;
	unsigned int nElementsWithoutInstancing;
	unsigned int nElements;

	unsigned int vertexStride;
	bool wideIndexBuffer;

	unsigned int nVertices;
	unsigned int nFaces;

	D3D11_PRIMITIVE_TOPOLOGY topology;

	HRESULT create(
		ID3D11Device* device,
		aiMesh* assMesh);

	Mass();
public:
	static HRESULT createMassFromFile(const char* assetFilename, 
		ID3D11Device* device,
		Mass** mass);
	~Mass();
	void draw(ID3D11DeviceContext* context);

	void getElements(const D3D11_INPUT_ELEMENT_DESC** elements, unsigned int* nElements);
	void getElementsWithoutInstancing(const D3D11_INPUT_ELEMENT_DESC** elements, unsigned int* nElements);
};

